    All Packages  Class Hierarchy  This Package  Previous  Next  Index

# Class java.text.DateFormat

    java.lang.Object
       |
       +----java.text.Format
               |
               +----java.text.DateFormat

public abstract class DateFormat
extends Format
implements Cloneable

DateFormat is an abstract class for date/time formatting subclasses which formats and parses dates or time in a language-independent manner. The date/time formatting subclass, such as SimpleDateFormat, allows for formatting (i.e., date -> text), parsing (text -> date), and normalization. The date is represented as a `Date` object or as the milliseconds since January 1, 1970, 00:00:00 GMT.

DateFormat provides many class methods for obtaining default date/time formatters based on the default or a given loacle and a number of formatting styles. The formatting styles include FULL, LONG, MEDIUM, and SHORT. More detail and examples of using these styles are provided in the method descriptions.

DateFormat helps you to format and parse dates for any locale. Your code can be completely independent of the locale conventions for months, days of the week, or even the calendar format: lunar vs. solar.

To format a date for the current Locale, use one of the static factory methods:

      myString = DateFormat.getDateInstance().format(myDate);

If you are formatting multiple numbers, it is more efficient to get the format and use it multiple times so that the system doesn't have to fetch the information about the local language and country conventions multiple times.

      DateFormat df = DateFormat.getDateInstance();
      for (int i = 0; i < a.length; ++i) {
        output.println(df.format(myDate[i]) + "; ");
      }

To format a number for a different Locale, specify it in the call to getDateInstance().

      DateFormat df = DateFormat.getDateInstance(Locale.FRANCE);

You can use a DateFormat to parse also.

      myDate = df.parse(myString);

Use getDate to get the normal date format for that country. There are other static factory methods available. Use getTime to get the time format for that country. Use getDateTime to get a date and time format. You can pass in different options to these factory methods to control the length of the result; from SHORT to MEDIUM to LONG to FULL. The exact result depends on the locale, but generally:

- SHORT is completely numeric, such as 12.13.52 or 3:30pm
- MEDIUM is longer, such as Jan 12, 1952
- LONG is longer, such as January 12, 1952 or 3:30:32pm
- FULL is pretty completely specified, such as Tuesday, April 12, 1952 AD or 3:30:42pm PST.

You can also set the time zone on the format if you wish. If you want even more control over the format or parsing, (or want to give your users more control), you can try casting the DateFormat you get from the factory methods to a SimpleDateFormat. This will work for the majority of countries; just remember to put it in a try block in case you encounter an unusual one.

You can also use forms of the parse and format methods with ParsePosition and FieldPosition to allow you to

- pregressively parse through pieces of a string.
- align any particular field, or find out where it is for selection on the screen.

See Also:
  Format, NumberFormat, SimpleDateFormat, Calendar, GregorianCalendar, TimeZone

##

AM_PM_FIELD
  Useful constant for AM_PM field alignment.
calendar
  The calendar that DateFormat uses to produce the time field values needed to implement date/time formatting.
DATE_FIELD
  Useful constant for DATE field alignment.
DAY_OF_WEEK_FIELD
  Useful constant for DAY_OF_WEEK field alignment.
DAY_OF_WEEK_IN_MONTH_FIELD
  Useful constant for DAY_OF_WEEK_IN_MONTH field alignment.
DAY_OF_YEAR_FIELD
  Useful constant for DAY_OF_YEAR field alignment.
DEFAULT
  Constant for default style pattern.
ERA_FIELD
  Useful constant for ERA field alignment.
FULL
  Constant for full style pattern.
HOUR0_FIELD
  Useful constant for zero-based HOUR field alignment.
HOUR1_FIELD
  Useful constant for one-based HOUR field alignment.
HOUR_OF_DAY0_FIELD
  Useful constant for zero-based HOUR_OF_DAY field alignment.
HOUR_OF_DAY1_FIELD
  Useful constant for one-based HOUR_OF_DAY field alignment.
LONG
  Constant for long style pattern.
MEDIUM
  Constant for medium style pattern.
MILLISECOND_FIELD
  Useful constant for MILLISECOND field alignment.
MINUTE_FIELD
  Useful constant for MINUTE field alignment.
MONTH_FIELD
  Useful constant for MONTH field alignment.
numberFormat
  The number formatter that DateFormat uses to format numbers in dates and times.
SECOND_FIELD
  Useful constant for SECOND field alignment.
SHORT
  Constant for short style pattern.
TIMEZONE_FIELD
  Useful constant for TIMEZONE field alignment.
WEEK_OF_MONTH_FIELD
  Useful constant for WEEK_OF_MONTH field alignment.
WEEK_OF_YEAR_FIELD
  Useful constant for WEEK_OF_YEAR field alignment.
YEAR_FIELD
  Useful constant for YEAR field alignment.

##

DateFormat()

##

clone()
  Overrides Cloneable
equals(Object)
  Overrides equals
format(Date)
  Formats a Date into a date/time string.
format(Date, StringBuffer, FieldPosition)
  Formats a Date into a date/time string.
format(Object, StringBuffer, FieldPosition)
  Overrides Format.
getAvailableLocales()
  Gets the set of locales for which DateFormats are installed.
getCalendar()
  Gets the calendar associated with this date/time formatter.
getDateInstance()
  Gets the date formatter with the default formatting style for the default locale.
getDateInstance(int)
  Gets the date formatter with the given formatting style for the default locale.
getDateInstance(int, Locale)
  Gets the date formatter with the given formatting style for the given locale.
getDateTimeInstance()
  Gets the date/time formatter with the default formatting style for the default locale.
getDateTimeInstance(int, int)
  Gets the date/time formatter with the given date and time formatting styles for the default locale.
getDateTimeInstance(int, int, Locale)
  Gets the date/time formatter with the given formatting styles for the given locale.
getInstance()
  Get a default date/time formatter that uses the SHORT style for both the date and the time.
getNumberFormat()
  Gets the number formatter which this date/time formatter uses to format and parse a time.
getTimeInstance()
  Gets the time formatter with the default formatting style for the default locale.
getTimeInstance(int)
  Gets the time formatter with the given formatting style for the default locale.
getTimeInstance(int, Locale)
  Gets the time formatter with the given formatting style for the given locale.
getTimeZone()
  Gets the time zone.
hashCode()
  Overrides hashCode
isLenient()
  Tell whether date/time parsing is to be lenient.
parse(String)
  Parse a date/time string.
parse(String, ParsePosition)
  Parse a date/time string according to the given parse position.
parseObject(String, ParsePosition)
  Parse a date/time string into an Object.
setCalendar(Calendar)
  Set the calendar to be used by this date format.
setLenient(boolean)
  Specify whether or not date/time parsing is to be lenient.
setNumberFormat(NumberFormat)
  Allows you to set the number formatter.
setTimeZone(TimeZone)
  Sets the time zone for the calendar of this DateFormat object.

##

calendar

     protected Calendar calendar

  The calendar that DateFormat uses to produce the time field values needed to implement date/time formatting. Subclasses should initialize this to the default calendar for the locale associated with this DateFormat.

numberFormat

     protected NumberFormat numberFormat

  The number formatter that DateFormat uses to format numbers in dates and times. Subclasses should initialize this to the default number format for the locale associated with this DateFormat.

ERA_FIELD

     public static final int ERA_FIELD

  Useful constant for ERA field alignment. Used in FieldPosition of date/time formatting.

YEAR_FIELD

     public static final int YEAR_FIELD

  Useful constant for YEAR field alignment. Used in FieldPosition of date/time formatting.

MONTH_FIELD

     public static final int MONTH_FIELD

  Useful constant for MONTH field alignment. Used in FieldPosition of date/time formatting.

DATE_FIELD

     public static final int DATE_FIELD

  Useful constant for DATE field alignment. Used in FieldPosition of date/time formatting.

HOUR_OF_DAY1_FIELD

     public static final int HOUR_OF_DAY1_FIELD

  Useful constant for one-based HOUR_OF_DAY field alignment. Used in FieldPosition of date/time formatting. HOUR_OF_DAY1_FIELD is used for the one-based 24-hour clock. For example, 23:59 + 01:00 results in 24:59.

HOUR_OF_DAY0_FIELD

     public static final int HOUR_OF_DAY0_FIELD

  Useful constant for zero-based HOUR_OF_DAY field alignment. Used in FieldPosition of date/time formatting. HOUR_OF_DAY0_FIELD is used for the zero-based 24-hour clock. For example, 23:59 + 01:00 results in 00:59.

MINUTE_FIELD

     public static final int MINUTE_FIELD

  Useful constant for MINUTE field alignment. Used in FieldPosition of date/time formatting.

SECOND_FIELD

     public static final int SECOND_FIELD

  Useful constant for SECOND field alignment. Used in FieldPosition of date/time formatting.

MILLISECOND_FIELD

     public static final int MILLISECOND_FIELD

  Useful constant for MILLISECOND field alignment. Used in FieldPosition of date/time formatting.

DAY_OF_WEEK_FIELD

     public static final int DAY_OF_WEEK_FIELD

  Useful constant for DAY_OF_WEEK field alignment. Used in FieldPosition of date/time formatting.

DAY_OF_YEAR_FIELD

     public static final int DAY_OF_YEAR_FIELD

  Useful constant for DAY_OF_YEAR field alignment. Used in FieldPosition of date/time formatting.

DAY_OF_WEEK_IN_MONTH_FIELD

     public static final int DAY_OF_WEEK_IN_MONTH_FIELD

  Useful constant for DAY_OF_WEEK_IN_MONTH field alignment. Used in FieldPosition of date/time formatting.

WEEK_OF_YEAR_FIELD

     public static final int WEEK_OF_YEAR_FIELD

  Useful constant for WEEK_OF_YEAR field alignment. Used in FieldPosition of date/time formatting.

WEEK_OF_MONTH_FIELD

     public static final int WEEK_OF_MONTH_FIELD

  Useful constant for WEEK_OF_MONTH field alignment. Used in FieldPosition of date/time formatting.

AM_PM_FIELD

     public static final int AM_PM_FIELD

  Useful constant for AM_PM field alignment. Used in FieldPosition of date/time formatting.

HOUR1_FIELD

     public static final int HOUR1_FIELD

  Useful constant for one-based HOUR field alignment. Used in FieldPosition of date/time formatting. HOUR1_FIELD is used for the one-based 12-hour clock. For example, 11:30 PM + 1 hour results in 12:30 AM.

HOUR0_FIELD

     public static final int HOUR0_FIELD

  Useful constant for zero-based HOUR field alignment. Used in FieldPosition of date/time formatting. HOUR0_FIELD is used for the zero-based 12-hour clock. For example, 11:30 PM + 1 hour results in 00:30 AM.

TIMEZONE_FIELD

     public static final int TIMEZONE_FIELD

  Useful constant for TIMEZONE field alignment. Used in FieldPosition of date/time formatting.

FULL

     public static final int FULL

  Constant for full style pattern.

LONG

     public static final int LONG

  Constant for long style pattern.

MEDIUM

     public static final int MEDIUM

  Constant for medium style pattern.

SHORT

     public static final int SHORT

  Constant for short style pattern.

DEFAULT

     public static final int DEFAULT

  Constant for default style pattern.

##

DateFormat

     protected DateFormat()

##

format

     public final StringBuffer format(Object obj,
                                      StringBuffer toAppendTo,
                                      FieldPosition fieldPosition)

  Overrides Format. Formats a time object into a time string. Examples of time objects are a time value expressed in milliseconds and a Date object.

  Parameters:
    obj - must be a Number or a Date.
    toAppendTo - the string buffer for the returning time string.
    status - the formatting status. On input: an alignment field, if desired. On output: the offsets of the alignment field.
  Returns:
    the formatted time string.
  Overrides:
    format in class Format
  See Also:
    Format

format

     public abstract StringBuffer format(Date date,
                                         StringBuffer toAppendTo,
                                         FieldPosition fieldPosition)

  Formats a Date into a date/time string.

  Parameters:
    date - a Date to be formatted into a date/time string.
    toAppendTo - the string buffer for the returning date/time string.
    status - the formatting status. On input: an alignment field, if desired. On output: the offsets of the alignment field. For example, given a time text "1996.07.10 AD at 15:08:56 PDT", if the given status.field is DateFormat.YEAR_FIELD, the offsets status.beginIndex and status.getEndIndex will be set to 0 and 4, respectively. Notice that if the same time field appears more than once in a pattern, the status will be set for the first occurence of that time field. For instance, formatting a Date to the time string "1 PM PDT (Pacific Daylight Time)" using the pattern "h a z (zzzz)" and the alignment field DateFormat.TIMEZONE_FIELD, the offsets status.beginIndex and status.getEndIndex will be set to 5 and 8, respectively, for the first occurence of the timezone pattern character 'z'.
  Returns:
    the formatted date/time string.

format

     public final String format(Date date)

  Formats a Date into a date/time string.

  Parameters:
    date - the time value to be formatted into a time string.
  Returns:
    the formatted time string.

parse

     public Date parse(String text) throws ParseException

  Parse a date/time string.

  Throws: ParseException
    If the given string cannot be parsed as a date.
  See Also:
    parse

parse

     public abstract Date parse(String text,
                                ParsePosition pos)

  Parse a date/time string according to the given parse position. For example, a time text "07/10/96 4:5 PM, PDT" will be parsed into a Date that is equivalent to Date(837039928046).

  By default, parsing is lenient: If the input is not in the form used by this object's format method but can still be parsed as a date, then the parse succeeds. Clients may insist on strict adherence to the format by calling setLenient(false).

  Parameters:
    text - The date/time string to be parsed
    pos - On input, the position at which to start parsing; on output, the position at which parsing terminated, or the start position if the parse failed.
  Returns:
    A Date, or null if the input could not be parsed
  See Also:
    setLenient

parseObject

     public Object parseObject(String source,
                               ParsePosition pos)

  Parse a date/time string into an Object. This convenience method simply calls parse(String, ParsePosition).

  Overrides:
    parseObject in class Format
  See Also:
    parse

getTimeInstance

     public static final DateFormat getTimeInstance()

  Gets the time formatter with the default formatting style for the default locale.

  Returns:
    a time formatter.

getTimeInstance

     public static final DateFormat getTimeInstance(int style)

  Gets the time formatter with the given formatting style for the default locale.

  Parameters:
    style - the given formatting style. For example, SHORT for "h:mm a" in the US locale.
  Returns:
    a time formatter.

getTimeInstance

     public static final DateFormat getTimeInstance(int style,
                                                    Locale aLocale)

  Gets the time formatter with the given formatting style for the given locale.

  Parameters:
    style - the given formatting style. For example, SHORT for "h:mm a" in the US locale.
    inLocale - the given locale.
  Returns:
    a time formatter.

getDateInstance

     public static final DateFormat getDateInstance()

  Gets the date formatter with the default formatting style for the default locale.

  Returns:
    a date formatter.

getDateInstance

     public static final DateFormat getDateInstance(int style)

  Gets the date formatter with the given formatting style for the default locale.

  Parameters:
    style - the given formatting style. For example, SHORT for "M/d/yy" in the US locale.
  Returns:
    a date formatter.

getDateInstance

     public static final DateFormat getDateInstance(int style,
                                                    Locale aLocale)

  Gets the date formatter with the given formatting style for the given locale.

  Parameters:
    style - the given formatting style. For example, SHORT for "M/d/yy" in the US locale.
    inLocale - the given locale.
  Returns:
    a date formatter.

getDateTimeInstance

     public static final DateFormat getDateTimeInstance()

  Gets the date/time formatter with the default formatting style for the default locale.

  Returns:
    a date/time formatter.

getDateTimeInstance

     public static final DateFormat getDateTimeInstance(int dateStyle,
                                                        int timeStyle)

  Gets the date/time formatter with the given date and time formatting styles for the default locale.

  Parameters:
    dateStyle - the given date formatting style. For example, SHORT for "M/d/yy" in the US locale.
    timeStyle - the given time formatting style. For example, SHORT for "h:mm a" in the US locale.
  Returns:
    a date/time formatter.

getDateTimeInstance

     public static final DateFormat getDateTimeInstance(int dateStyle,
                                                        int timeStyle,
                                                        Locale aLocale)

  Gets the date/time formatter with the given formatting styles for the given locale.

  Parameters:
    dateStyle - the given date formatting style.
    timeStyle - the given time formatting style.
    inLocale - the given locale.
  Returns:
    a date/time formatter.

getInstance

     public static final DateFormat getInstance()

  Get a default date/time formatter that uses the SHORT style for both the date and the time.

getAvailableLocales

     public static Locale[] getAvailableLocales()

  Gets the set of locales for which DateFormats are installed.

  Returns:
    the set of locales for which DateFormats are installed.

setCalendar

     public void setCalendar(Calendar newCalendar)

  Set the calendar to be used by this date format. Initially, the default calendar for the specified or default locale is used.

getCalendar

     public Calendar getCalendar()

  Gets the calendar associated with this date/time formatter.

  Returns:
    the calendar associated with this date/time formatter.

setNumberFormat

     public void setNumberFormat(NumberFormat newNumberFormat)

  Allows you to set the number formatter.

  Parameters:
    newNumberFormat - the given new NumberFormat.

getNumberFormat

     public NumberFormat getNumberFormat()

  Gets the number formatter which this date/time formatter uses to format and parse a time.

  Returns:
    the number formatter which this date/time formatter uses.

setTimeZone

     public void setTimeZone(TimeZone zone)

  Sets the time zone for the calendar of this DateFormat object.

  Parameters:
    zone - the given new time zone.

getTimeZone

     public TimeZone getTimeZone()

  Gets the time zone.

  Returns:
    the time zone associated with the calendar of DateFormat.

setLenient

     public void setLenient(boolean lenient)

  Specify whether or not date/time parsing is to be lenient. With lenient parsing, the parser may use heuristics to interpret inputs that do not precisely match this object's format. With strict parsing, inputs must match this object's format.

  See Also:
    setLenient

isLenient

     public boolean isLenient()

  Tell whether date/time parsing is to be lenient.

hashCode

     public int hashCode()

  Overrides hashCode

  Overrides:
    hashCode in class Object

equals

     public boolean equals(Object obj)

  Overrides equals

  Overrides:
    equals in class Object

clone

     public Object clone()

  Overrides Cloneable

  Overrides:
    clone in class Format

    All Packages  Class Hierarchy  This Package  Previous  Next  Index

Submit a bug or feature - Version 1.1.8 of Java Platform API Specification
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1995-1999 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.